program Practica (input, output);

uses crt,Graph;

type
   info = record
        angle: Integer;
        altura: Integer;
        zoom: Integer;
        pinces: Char;
        end;

   tzoom = record
         inix,iniy: integer;
         fix,fiy: integer;
         end;
   tpinca_cos = record
             inix, iniy:integer;
             fix,fiy:integer;
             end;
   tpinca_av = record
             inix, iniy:integer;
             fix,fiy:integer;
             end;

   tpinca_am = record
             inix, iniy:integer;
             fix,fiy:integer;
             end;

   tpinca_circ = record
             inix, iniy:integer;
             end;

   trotacio = record
             inix, iniy:integer;
             fix,fiy:integer;
             end;

   artic = record               { articulacions del robot }
         zoom: tzoom;
         pinca_av: tpinca_av;
         pinca_am: tpinca_am;
         pinca_cos: tpinca_cos;
         pinca_circ: tpinca_circ;
         rotacio: trotacio;
         end;


 Var
   grDriver,grMode,ErrCode,x1,y1,x2,y2,a,b:integer;
   dades:info;
   art: artic;
   menu, mostrar:info;
   Gd, Gm: Integer;
   Radius: Integer;
   Color: Word;
   Palette: PaletteType;


(******************************************************************)
(************ R U T I N E S     A U X I L I A R S *****************)


(* Inicialitzaci del mode grfic *)
procedure Inicialitzar_mode_grafic;
begin
  grDriver := 0;
  InitGraph(grDriver, grMode,'c:\tp\bgi ');
  ErrCode := GraphResult;
  if ErrCode<>grOk then
    begin
      Writeln('Graphics error:', GraphErrorMsg(ErrCode));
      halt;
    end;
end;


procedure Inicialitza_posicio(var art:artic; var dades:info);
var anglesin, anglecos: integer;
begin

  art.rotacio.inix:=470;                 { dibuixa angle inicial }
  art.rotacio.iniy:=130;
  anglesin:=Trunc(sin(dades.angle));
  anglecos:=Trunc(cos(dades.angle));
  art.rotacio.fix:=470 + (30 * anglesin);
  art.rotacio.fiy:=130 + (30 * anglecos);

  art.pinca_circ.inix:=art.rotacio.fix;  { dibuixa la pinca }
  art.pinca_circ.iniy:=art.rotacio.fiy;
  circle(art.pinca_circ.inix, art.pinca_circ.iniy,8);

  art.zoom.inix:=80;                     { dibuixa altura i zoom }
  art.zoom.iniy:=(120 - dades.altura);
  art.zoom.fiy:=(120 - dades.altura);
  art.zoom.fix:=(130 + dades.zoom);

  art.pinca_cos.inix:=art.zoom.inix;    { dibuixa la pinca }
  art.pinca_cos.iniy:=(art.zoom.iniy - 10);
  art.pinca_cos.fix:=art.zoom.inix;
  art.pinca_cos.fiy:=(art.zoom.iniy + 10);

  if ( (dades.pinces = 'o') or (dades.pinces = 'O') ) then
   begin
    art.pinca_am.inix:=art.pinca_cos.inix;
    art.pinca_am.iniy:=art.pinca_cos.iniy;
    art.pinca_am.fix:=(art.pinca_cos.inix + 20);
    art.pinca_am.fiy:=art.pinca_cos.iniy;

    art.pinca_av.inix:=art.zoom.inix;
    art.pinca_av.iniy:=art.pinca_cos.fiy;
    art.pinca_av.fix:=art.zoom.inix;
    art.pinca_av.fiy:=(art.zoom.iniy + 10);
   end;

    if ( (dades.pinces = 't') or (dades.pinces = 'T') ) then
      begin
       art.pinca_am.inix:=art.pinca_cos.inix;
       art.pinca_am.iniy:=art.pinca_cos.iniy;
       art.pinca_am.fix:=(art.pinca_cos.inix + 20);
       art.pinca_am.fiy:=art.pinca_cos.iniy;

    art.pinca_av.inix:=art.zoom.inix;
    art.pinca_av.iniy:=art.pinca_cos.fiy;
    art.pinca_av.fix:=art.zoom.inix;
    art.pinca_av.fiy:=(art.zoom.iniy + 10);
   end;
end;


procedure Dibuixa(art:artic; dades: info);
begin
  { clearviewport;}

  line(100,270,500,270);                { quadre del menu.}
  line(100,270,100,440);
  line(100,440,500,440);
  line(500,270,500,440);
  line (320,30,620,30);                 { quadre de dalt a la dreta}
  line (320,30,320,250);
  line (320,250,620,250);
  line(620,30,620,250);
  line (0,30,300,30);                   { quadre de dalt a l'esquerra}
  line (0,30,0,250);
  line (0,250,300,250);
  line(300,30,300,250);
  outtextxy (110,305, 'Angle (en graus): ');
  writeln(dades.angle);

  for Radius := 1 to 1 do               { dibuixa base del robot }
    Circle(470, 135,radius * 30);

  line(50,200,110,200);                  { dibuixa base del robot}
  line(80,200,80,70);                    { eix moblible de dalt a baix}

  line(art.zoom.inix, art.zoom.iniy, art.zoom.fix, art.zoom.fiy);
  line(art.pinca_cos.inix, art.pinca_cos.iniy, art.pinca_cos.fix,art.pinca_cos.fiy);
  line(art.pinca_cos.inix, art.pinca_cos.iniy, art.pinca_cos.fix,art.pinca_cos.fiy);
end;


procedure Moviment(var dades:info; var art:artic);
var tecla: Char;
  marxar: integer;
begin
  marxar:=0;
  grDriver := 0;
  InitGraph(grDriver, grMode,'c:\tp\bgi ');
  While (marxar = 0) do
   begin
    {dibuixar_Z(dades,art}

    tecla:=readkey;
    clearviewport;
    {cleardevice;}
    if ((tecla ='q')  or (tecla='Q'))then
      begin
        art.zoom.iniy:=art.zoom.iniy+2;   {puja barra horitzontal }
        art.zoom.fiy:=art.zoom.fiy+2;
        Dibuixa(art,dades);
      end;

    if ((tecla ='z')  or (tecla='Z'))then
      begin
        art.zoom.iniy:=art.zoom.iniy-2;   {baixa barra horitzontal.}
        art.zoom.fiy:=art.zoom.fiy-2;
        Dibuixa(art,dades);
      end;


(*
  art.pinca_cos.iniy:=art.pinca_cos.iniy+2;  {la pina far un zoom endavan}
  art.pinca_cos.fiy:=art.pinca_cos.fiy+2;



  art.pinca_cos.iniy:=art.pinca_cos.iniy-2;  {la pina far un zoom enderrera}
  art.pinca_cos.fiy:=art.pinca_cos.fiy-2;

{
  if ((tecla ='p')  or (tecla='P'))then
    dibuixar_P(dades,art);
  if ((tecla ='i')  or (tecla='I'))then
    dibuixar_I(dades,art);
    }


  art.pinca_av.iniy:=art.pinca_av.iniy+2;  {la pina es tancar.}
  art.pinca_av.fiy:=art.pinca_av.fiy+2;


begin
  art.pinca_am.iniy:=art.pinca_am.iniy-2;  {la pina s'obrir.}
  art.pinca_am.fiy:=art.pinca_am.fiy-2;
end;

  if ((tecla ='t')  or (tecla='T'))then
    line (60,60,70,70);
     if ((tecla ='t')  or (tecla='T'))then
    line (60,80,70,70);

  if ((tecla ='o')  or (tecla='O'))then
    line (60,60,70,60);
     if ((tecla ='o') or (tecla='O'))then
    line (60,80,70,80);
begin
  art.rotacio.iniy:=art.rotacio.iniy+2;  {el bra girar sentit antihorari.}
  art.rotacio.fiy:=art.rotacio.fiy+2;
end;

begin
  art.rotacio.iniy:=art.rotacio.iniy-2;  {el bra girar sentit horari.}
  art.rotacio.fiy:=art.rotacio.fiy-2;
end;

  if ((tecla ='a')  or (tecla='A'))then
     line (100,80,80,60);

  if ((tecla ='h')  or (tecla='H'))then
     line (100,80,120,60);
                                                                           *)

   outtextxy(110,430,'pulsa la tecla (M) per sortir del programa.');
   if (tecla = 'm') then marxar:=1;
 end;
end;


procedure Menu(var dades:info);
begin

  line(100,270,500,270);{cuadre del menu.}
  line(100,270,100,440);
  line(100,440,500,440);
  line(500,270,500,440);

  outtextxy (280,280, 'MENU');
  outtextxy(110,290, ' ');
  outtextxy (110,305, 'Angle ? (en graus) ');
  gotoXY(35,20);
  readln (dades.angle);
  while ( (dades.angle > 360) or (dades.angle < 0) ) do
   begin
    outtextxy(110,305, 'Angle incorrecte');
    outtextxy (110,315, 'Angle ? (en graus) ');
    gotoXY(35,20);
    readln (dades.angle);
   end;

(*  Gd := Detect;

  if  GraphResult <> grOk then Halt(1);
  for Radius := 1 to 1 do Circle(470, 135,radius * 30);

  line (470,135,470,100);{eix del robot}
  line (460,100,480,100);{eix que es velluga segons els graus.}
  line (460,100,460,70);{pines}
  line (480,100,480,70);
  line (460,70,470,60);
  line (480,70,470,60);


  line (320,30,620,30);{cuadre de dalt a la dreta}
  line (320,30,320,250);
  line (320,250,620,250);
  line(620,30,620,250);
    {estaria b que sortis l'angle l'altura i el zoom
     i obrir i tancar les pinces tot en el mateix moment.} *)
  outtextxy (110,330, 'Altura ? (en cm.) ');
  gotoXY(35,22);
  readln (dades.altura);
  while ( (dades.altura > 50) or (dades.altura < -50) ) do
   begin
    outtextxy(110,330, 'Altura incorrecte');
    outtextxy (110,340, 'Altura ? (en cm.) ');
    gotoXY(35,22);
    readln (dades.altura);
   end;

  outtextxy (110,360, 'Zoom ? (en cm.) ');
  gotoXY(35,24);
  readln (dades.zoom);             (* zoom *)
  while ( (dades.zoom > 50) or (dades.zoom < -50) ) do
   begin
    outtextxy(110,360, 'Zoom incorrecte');
    outtextxy (110,380, 'Zoom ? (en cm.) ');
    gotoXY(35,24);
    readln (dades.zoom);
  end;

  outtextxy (110,390, 'Obrir pinces (o), Tancar pinces (t) ?  ');
  gotoxy(53,26);
  readln (dades.pinces);
  while ( (dades.pinces <> 'o') and (dades.pinces <> 't') ) do
   begin
    outtextxy (110,400, 'Pinces obertes, pulsa la lletra o');
    outtextxy (110,410, 'Pinces tancades, pulsa la lletra t');
    outtextxy (110,420, 'Obrir pinces (o), Tancar pinces (t) ?  ');
    gotoxy(53,26);
    readln (dades.pinces);
   end;
(*
  line(50,200,110,200);{base del robot}
  line(80,200,80,70);{eix moblible de dalt a baix}
  line(80,70,120,70);
  line(120,60,120,80);{pines que s'obren i es
                       tanquen i a mes a mes tenen zom}
  line(120,80,160,80);
  line(120,60,160,60);
*)
  line (0,30,300,30);{cuadre de dalt a l'esquerra}
  line (0,30,0,250);
  line (0,250,300,250);
  line(300,30,300,250);
end;



(************** P R O G R A M A    P R I N C I P A L  *****************)

begin
  Inicialitzar_mode_grafic;
  Menu(dades);
  Inicialitza_posicio(art,dades);
  Dibuixa(art,dades);

  readln;
  Moviment(dades,art);
  KeyPressed;
  closegraph;

end.