
program Practica (input, output);


uses crt,Graph;

type
   info = record
        angle: Integer;
        altura: Integer;
        zoom: Integer;
        pinces: Char;
        end;

   tzoom = record
         inix,iniy: integer;
         fix,fiy: integer;
         end;
   tpinca_cos = record
             inix, iniy:integer;
             fix,fiy:integer;
             end;
   tpinca_av = record
             inix, iniy:integer;
             fix,fiy:integer;
             end;

   tpinca_am = record
             inix, iniy:integer;
             fix,fiy:integer;
             end;

   tpinca_circ = record
             inix, iniy:integer;
             end;

   trotacio = record
             inix, iniy:integer;
             fix,fiy:integer;
             end;

   artic = record               { articulacions del robot }
         zoom: tzoom;
         pinca_av: tpinca_av;
         pinca_am: tpinca_am;
         pinca_cos: tpinca_cos;
         pinca_circ: tpinca_circ;
         rotacio: trotacio;
         end;


 Var
   grDriver,grMode,ErrCode,x1,y1,x2,y2,a,b:integer;
   dades:info;
   menu, mostrar:info;
   Gd, Gm: Integer;
   Radius, angle, llargada: Integer;
   Color: Word;
   Palette: PaletteType;
   art: artic;
procedure Inicialitzar_mode_grafic;
begin
 grDriver :=0;
 InitGraph(grDriver, grMode,'c:\tp\bgi ');
 ErrCode := GraphResult;
 if ErrCode<>grOk then
            begin
              Writeln('Graphics error:', GraphErrorMsg(ErrCode));
              halt;

            end;
end;


procedure Inicialitza_posicio(var art:artic; var dades:info;
                              var angle:integer; var llargada:integer);

var anglesin, anglecos: integer;
    aux0, aux00:real;
begin

    art.rotacio.inix:=470;                 { dibuixa angle inicial }
    art.rotacio.iniy:=135;

    angle:= dades.angle;                  { variable angle global }
    llargada:=Trunc(Abs(dades.zoom))+ 50;
    if dades.angle = 360 then dades.angle:=0;
    aux0:=llargada * sin( (pi/180)*(dades.angle) );
    anglesin:=Trunc(aux0);
    aux00:=llargada * cos( (pi/180)*(dades.angle) );
    anglecos:=Trunc(aux00);
    art.rotacio.fix:=470 + anglesin;
    art.rotacio.fiy:=135 - anglecos;


    art.pinca_circ.inix:=art.rotacio.fix;  { dibuixa la pinca }
    art.pinca_circ.iniy:=art.rotacio.fiy;
    circle (art.pinca_circ.inix, art.pinca_circ.iniy,8);

         art.zoom.inix:=80;                     { dibuixa altura i zoom }
         art.zoom.iniy:=(120 - dades.altura);
         art.zoom.fiy:=(120 - dades.altura);
         art.zoom.fix:=(130 + dades.zoom);

         art.pinca_cos.inix:=art.zoom.fix;    { dibuixa la pinca }
         art.pinca_cos.iniy:=(art.zoom.iniy - 10);
         art.pinca_cos.fix:=art.zoom.fix;
         art.pinca_cos.fiy:=(art.zoom.iniy + 10);

  if ( (dades.pinces = 'o') or (dades.pinces = 'O') ) then
      begin
         art.pinca_am.inix:=art.pinca_cos.fix;
         art.pinca_am.iniy:=art.pinca_cos.iniy;
         art.pinca_am.fix:=(art.pinca_cos.inix + 20);
         art.pinca_am.fiy:=art.pinca_cos.iniy;

         art.pinca_av.inix:=art.zoom.fix;
         art.pinca_av.iniy:=art.pinca_cos.fiy;
         art.pinca_av.fix:=(art.pinca_cos.inix + 20);
         art.pinca_av.fiy:=art.pinca_cos.fiy ;
   end;

    if ( (dades.pinces = 't') or (dades.pinces = 'T') ) then
      begin
         art.pinca_am.inix:=art.pinca_cos.fix;
         art.pinca_am.iniy:=art.pinca_cos.iniy;
         art.pinca_am.fix:=(art.pinca_cos.inix + 20);
         art.pinca_am.fiy:=(art.pinca_cos.iniy + 10);

         art.pinca_av.inix:=art.zoom.fix;
         art.pinca_av.iniy:=art.pinca_cos.fiy;
         art.pinca_av.fix:=(art.pinca_cos.inix + 20);
         art.pinca_av.fiy:=(art.pinca_cos.fiy - 10);
   end;
end;


procedure Dibuixa(art:artic;dades:info);

begin

  clearviewport;
  (*
  line(100,270,500,270);                { quadre del menu.}
  line(100,270,100,440);
  line(100,440,500,440);
  line(500,270,500,440); *)

  line (320,30,620,30);                 { quadre de dalt a la dreta}
  line (320,30,320,250);
  line (320,250,620,250);
  line(620,30,620,250);

  line (0,30,300,30);{cuadre de dalt a l'esquerra}
  line (0,30,0,250);
  line (0,250,300,250);
  line(300,30,300,250);

  (*
  outtextxy (280,280, 'MENU');
  outtextxy(110,290, ' ');

  outtextxy (110,305, 'Angle ? (en graus) ');
  gotoxy(35,20);


  outtextxy (110,330, 'Altura ? (en cm.) ');
  gotoXY(35,21);

  outtextxy (110,360, 'Zoom ? (en cm.) ');
  gotoXY(35,23);

  outtextxy (110,390, 'Obrir pinces (o), Tancar pinces (t) ?  ');
  gotoxy(53,25);
    *)
    for Radius := 1 to 1 do               { dibuixa base del robot }
    Circle(470, 135,radius * 30);

  line(50,200,110,200);                  { dibuixa base del robot}
  line(80,200,80,70);                    { eix moblible de dalt a baix}

  line(art.zoom.inix, art.zoom.iniy, art.zoom.fix, art.zoom.fiy);
  line(art.pinca_cos.inix, art.pinca_cos.iniy, art.pinca_cos.fix,art.pinca_cos.fiy);
  line(art.pinca_av.inix, art.pinca_av.iniy, art.pinca_av.fix,art.pinca_av.fiy);
  line(art.pinca_am.inix, art.pinca_am.iniy, art.pinca_am.fix,art.pinca_am.fiy);
  line(art.rotacio.inix, art.rotacio.iniy, art.rotacio.fix, art.rotacio.fiy);
  pieslice(art.pinca_circ.inix, art.pinca_circ.iniy,0,360,8);
  circle(art.pinca_circ.inix, art.pinca_circ.iniy,8);

end;

procedure Moviment(var dades:info; var art:artic;var angle:integer;
                   var llargada: integer);
var anglesin, anglecos: integer;
    tecla: Char;
    marxar: integer;
    aux0, aux00: real;
begin

  marxar:=0;
  grDriver := 0;
  InitGraph(grDriver, grMode,'c:\tp\bgi ');
  outtextxy(15,15, 'COMENCAR ');
  While (marxar = 0) do

begin

    {dibuixar_Z(dades,art}

    tecla:=readkey;
   { clearviewport;}
    {cleardevice;}

 if ((tecla ='q')  or (tecla='Q'))then

 begin
  if art.zoom.iniy > 70 then
    begin

  art.zoom.iniy:=art.zoom.iniy-2;   {puja barra horitzontal }
  art.zoom.fiy:=art.zoom.fiy-2;
  art.pinca_cos.iniy:=art.pinca_cos.iniy - 2;
  art.pinca_cos.fiy:=art.pinca_cos.fiy - 2;
  art.pinca_av.iniy:=art.pinca_av.iniy - 2;
  art.pinca_av.fiy:=art.pinca_av.fiy - 2;
  art.pinca_am.iniy:=art.pinca_am.iniy - 2;
  art.pinca_am.fiy:=art.pinca_am.fiy - 2;
  dibuixa(art,dades);
  end;
 end;

 if ((tecla ='z')  or (tecla='Z'))then
 begin
  if art.zoom.iniy < 170 then
    begin
  art.zoom.iniy:=art.zoom.iniy+2;   {baixa barra horitzontal.}
  art.zoom.fiy:=art.zoom.fiy+2;
   art.pinca_cos.iniy:=art.pinca_cos.iniy + 2;
  art.pinca_cos.fiy:=art.pinca_cos.fiy + 2;
  art.pinca_av.iniy:=art.pinca_av.iniy + 2;
  art.pinca_av.fiy:=art.pinca_av.fiy + 2;
  art.pinca_am.iniy:=art.pinca_am.iniy + 2;
  art.pinca_am.fiy:=art.pinca_am.fiy + 2;
  dibuixa(art,dades);
  end;
 end;

  if ((tecla ='p')  or (tecla='P'))then
  begin
  if art.zoom.fix < 190 then
        begin
  llargada:=llargada+2;
   aux0:=llargada * sin( (pi/180)*(angle) );
      anglesin:=Trunc(aux0);
      aux00:=llargada * cos( (pi/180)*(angle) );
      anglecos:=Trunc(aux00);
      art.rotacio.fix:=470 + anglesin;
      art.rotacio.fiy:=135 - anglecos;
      art.pinca_circ.inix:=art.rotacio.fix;  { dibuixa la pinca }
      art.pinca_circ.iniy:=art.rotacio.fiy;
      circle (art.pinca_circ.inix, art.pinca_circ.iniy,8);

  art.pinca_cos.inix:=art.pinca_cos.inix + 2;  {la pina far un zoom endavant}
  art.pinca_cos.fix:=art.pinca_cos.fix + 2;
  art.pinca_av.inix:=art.pinca_av.inix + 2;
  art.pinca_av.fix:=art.pinca_av.fix + 2;
  art.pinca_am.inix:=art.pinca_am.inix + 2;
  art.pinca_am.fix:=art.pinca_am.fix + 2;
  art.zoom.fix:=art.zoom.fix + 2;
   dibuixa(art,dades);
   end;
end;

  if ((tecla ='i')  or (tecla='I'))then
  begin
  if art.zoom.fix > 90 then
    begin
  llargada:=llargada-2;
   aux0:=llargada * sin( (pi/180)*(angle) );
      anglesin:=Trunc(aux0);
      aux00:=llargada * cos( (pi/180)*(angle) );
      anglecos:=Trunc(aux00);
      art.rotacio.fix:=470 + anglesin;
      art.rotacio.fiy:=135 - anglecos;
      art.pinca_circ.inix:=art.rotacio.fix;  { dibuixa la pinca }
      art.pinca_circ.iniy:=art.rotacio.fiy;
      circle (art.pinca_circ.inix, art.pinca_circ.iniy,8);
     
  art.pinca_cos.inix:=art.pinca_cos.inix - 2;  {la pina far un zoom enderrera}
  art.pinca_cos.fix:=art.pinca_cos.fix - 2;
  art.pinca_av.inix:=art.pinca_av.inix - 2;
  art.pinca_av.fix:=art.pinca_av.fix - 2;
  art.pinca_am.inix:=art.pinca_am.inix - 2;
  art.pinca_am.fix:=art.pinca_am.fix - 2;
  art.zoom.fix:=art.zoom.fix - 2;

   dibuixa(art,dades);
   end;
end;

  if ((tecla ='t')  or (tecla='T'))then
       begin
         art.pinca_am.inix:=art.pinca_cos.fix;
         art.pinca_am.iniy:=art.pinca_cos.iniy;
         art.pinca_am.fix:=(art.pinca_cos.inix + 20);
         art.pinca_am.fiy:=(art.pinca_cos.iniy + 10);

         art.pinca_av.inix:=art.zoom.fix;
         art.pinca_av.iniy:=art.pinca_cos.fiy;
         art.pinca_av.fix:=(art.pinca_cos.inix + 20);
         art.pinca_av.fiy:=(art.pinca_cos.fiy - 10);
    dibuixa(art,dades);
end;
  if ((tecla ='o')  or (tecla='O'))then   {obrir la pina}
   begin
         art.pinca_am.inix:=art.pinca_cos.fix;
         art.pinca_am.iniy:=art.pinca_cos.iniy;
         art.pinca_am.fix:=(art.pinca_cos.inix + 20);
         art.pinca_am.fiy:=art.pinca_cos.iniy;

         art.pinca_av.inix:=art.zoom.fix;
         art.pinca_av.iniy:=art.pinca_cos.fiy;
         art.pinca_av.fix:=(art.pinca_cos.inix + 20);
         art.pinca_av.fiy:=art.pinca_cos.fiy ;

    dibuixa (art,dades);
   end;
  if ((tecla ='a')  or (tecla='A'))then
  begin
    if (angle >= 4) then
      angle:=angle - 4;
      aux0:=llargada * sin( (pi/180)*(angle) );
      anglesin:=Trunc(aux0);
      aux00:=llargada * cos( (pi/180)*(angle) );
      anglecos:=Trunc(aux00);
      art.rotacio.fix:=470 + anglesin;
      art.rotacio.fiy:=135 - anglecos;
      art.pinca_circ.inix:=art.rotacio.fix;  { dibuixa la pinca }
      art.pinca_circ.iniy:=art.rotacio.fiy;
      circle (art.pinca_circ.inix, art.pinca_circ.iniy,8);
      dibuixa (art,dades);
    end;

  if ((tecla ='h')  or (tecla='H'))then
     begin
     if (angle < 360) then
      angle:=angle + 4;
      aux0:=llargada * sin( (pi/180)*(angle) );
      anglesin:=Trunc(aux0);
      aux00:=llargada * cos( (pi/180)*(angle) );
      anglecos:=Trunc(aux00);
      art.rotacio.fix:=470 + anglesin;
      art.rotacio.fiy:=135 - anglecos;
      art.pinca_circ.inix:=art.rotacio.fix;  { dibuixa la pinca }
      art.pinca_circ.iniy:=art.rotacio.fiy;
      circle (art.pinca_circ.inix, art.pinca_circ.iniy,8);

    dibuixa (art,dades);

   end;

      outtextxy(110,430,'pulsa la tecla (M) per sortir del programa.');
   if (tecla = 'm') then marxar:=1;
 end;


end;
procedure Dibuixar_pantalla;
var tecla: Char;
  marxar: integer;

begin
begin

  line(100,270,500,270);{cuadre del menu.}
  line(100,270,100,440);
  line(100,440,500,440);
  line(500,270,500,440);

  outtextxy (280,280, 'MENU');
  outtextxy(110,290, ' ');
  outtextxy (110,305, 'Angle ? (en graus) ');
  gotoXY(35,20);
  outtextxy (110,330, 'Altura ? (en cm.) ');
  outtextxy (110,360, 'Zoom ? (en cm.) ');

  outtextxy (110,390, 'Obrir pinces (o), Tancar pinces (t) ?  ');
  outtextxy(110,430,'pulsa la tecla (M) per sortir del programa.');
  if (tecla = 'm') then marxar:=1;

 readln (dades.angle);
  end;
  while ( (dades.angle > 360) or (dades.angle < 0) ) do
   begin
    outtextxy(110,305, 'Angle incorrecte');
    outtextxy (110,315, 'Angle ? (en graus) ');
    gotoXY(35,20);
    readln (dades.angle);
   end;

  gotoXY(35,21);
  readln (dades.altura);
  while ( (dades.altura > 50) or (dades.altura < -50) ) do
    begin
    outtextxy(110,340, 'Altura incorrecte');
    outtextxy (110,350, 'Altura ? (en cm.) ');
    gotoXY(35,21);
    readln (dades.altura);
   end;
     gotoXY(35,23);
     readln (dades.zoom);             (* zoom *)
  while ( (dades.zoom > 50) or (dades.zoom < -50) ) do
   begin
    outtextxy(110,370, 'Zoom incorrecte');
    outtextxy (110,380, 'Zoom ? (en cm.) ');
    gotoXY(35,23);
    readln (dades.zoom);
end;
  gotoxy(53,25);
  readln (dades.pinces);
  while ( (dades.pinces <> 'o') and (dades.pinces <> 't') ) do
 begin
    outtextxy (110,400, 'Pinces obertes, pulsa la lletra o');
    outtextxy (110,410, 'Pinces tancades, pulsa la lletra t');
    outtextxy (110,420, 'Obrir pinces (o), Tancar pinces (t) ?  ');
    gotoxy(53,25);

end;
end;
begin
  Inicialitzar_mode_grafic;
  Dibuixar_pantalla;
  Inicialitza_posicio(art,dades,angle,llargada);
  Moviment(dades,art,angle,llargada);
  Dibuixa(art,dades);
  KeyPressed;
  closegraph;



end.